﻿--[[
--                                           TJS ©2015 through 2016 or (c)2015 through 2016
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Creation
--------------------------------------------------------------------------------------------------------------------------------
local color = {
	["stalk"] = "|cffA4FCA4";
	["hellbane"] = "|cff01B8FB";
	["plan"] = "|cffFAD996";
	["fang"] = "|cffFCA7A1";
	["title"] = "|cffFFFFFF",
	["planName"] = "\n|cffFDF97CPlan: ";
	["inCave"] = "\n|cffFB693D",
	["caveEnt"] = "|cffFB693D",
	["event"] = "\n|cff41D344",
	["alert"] = "\n|cffFF0000",
	["summon"] = "\n|cffFBE23D",
	["fangRep"] = "\n|cff019AF9";
	["fangQ"] = "\n|cffFFF63A";
};

local text = {
	["inCave"] = color.inCave.."LOCATED IN CAVE|r\nsee Cave Entrance",
	["caveEnt"] = color.caveEnt.."CAVE ENTRANCE|r\n",
	["event"] = color.event.."Spawns as an EVENT".."|r",
	["summon"] = color.summon.."Must be SUMMONED".."|r",
	["fangRep"] = color.fangRep.."The Saberstalkers Reputation".."|r",
	["fangQ"] = color.fangQ.."! Rumble in the Jungle".."|r",
};

function TJS_SetSSRep()
	text["SSRep"] = text.fangRep;
	local value = true;
	local faction, description, REP = GetFactionInfoByID(1850);
--	if REP > 6 then
--		value = false;
--		text["SSRep"] = "";
--	end
--	return value; ======================== This was used to stop rep gains above Revered. 
-- ======================================= Such gains continue throughout. 
	return value;
end

function TJS_SetPos(x,y,name)
	TJS[name] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["coord"] = name;
		["class"] = {
			["stalk"] = true;
			["plan"] = false;
			["hellbane"] = false;
			["fang"] = false;
		},
		["text"] = {
			["name"] = "",
			["title"] = "",
			["plan"] = "",
			["fang"] = "",
			["text"] = ""
		},
		["number"] = {
			["plan"] = 0,
			["today"] = 0,
		},
		["flag"] = {
			["achievement"] = false,
			["plan"] = false,
			["today"] = false,
			["inCave"] = false,
			["event"] = false,
			["summon"] = false,
			["fangRep"] = false,
			["SET"] = false,
		},
	};
end

function TJS_Create()
	TJS = nil;
	TJS = {};
	
	TJS_SetPos(54.3,81.0,"Akrrilo");
	TJS_SetPos(53.0,40.6,"Argosh the Destroyer");
	TJS_SetPos(34.9,47.1,"Belgork");
	TJS_SetPos(23.8,51.9,"Bilkor the Thrower");
	TJS_SetPos(50.0,74.0,"Bleeding Hollow Horror");
	TJS_SetPos(21.2,42.2,"Bloodhunter Zulk");
	TJS_SetPos(40.7,69.8,"Bramblefell");
	TJS_SetPos(57.4,67.9,"Broodlord Ixkor");
	TJS_SetPos(48.0,57.2,"Captain Grok'mar");
	TJS_SetPos(35.6,79.9,"(The Real) Captain Ironbeard");
	TJS_SetPos(30.9,68.3,"Ceraxas");
	TJS_SetPos(44.4,37.3,"Cindral the Wildfire");
	TJS_SetPos(15.2,54.5,"Commander Krag'goth");
	TJS_SetPos(51.0,46.0,"Commander Org'mok");
	TJS_SetPos(23.5,46.8,"Dorg the Bloody");
	TJS_SetPos(19.8,53.6,"Driss Vile");
	TJS_SetPos(25.1,46.6,"Drivnul");
	TJS_SetPos(49.5,36.5,"Executor Riloth");
	TJS_SetPos(54.3,81.0,"Eyepiercer");
	TJS_SetPos(28.7,51.0,"Felbore");
	TJS_SetPos(45.8,47.0,"Felsmith Damorka");
	TJS_SetPos(52.0,26.4,"Felspark");
	TJS_SetPos(63.2,80.0,"Gloomtalon");
	TJS_SetPos(34.5,78.3,"Glub'glok");
	TJS_SetPos(33.3,35.8,"Gorabosh");
	TJS_SetPos(47.5,42.3,"Grand Warlock Nethekurse");
	TJS_SetPos(15.9,59.7,"Grannok");
	TJS_SetPos(39.6,32.6,"Harbormaster Korak");
	TJS_SetPos(31.5,73.5,"Imp-Master Valessa");
	TJS_SetPos(26.8,76.1,"Jax'zor");
	TJS_SetPos(52.0,83.8,"Krell the Serene");
	TJS_SetPos(39.6,68.4,"Kris'kar the Unredeemed");
	TJS_SetPos(32.5,74.0,"Lady Oran");
	TJS_SetPos(52.4,62.5,"Magwia");
	TJS_SetPos(25.5,79.2,"Mistress Thavra");
	TJS_SetPos(53.0,20.0,"Overlord Ma'gruth");
	TJS_SetPos(53.6,21.6,"Painmistress Selora");
	TJS_SetPos(16.8,48.8,"Podlord Wakkawam");
	TJS_SetPos(56.7,24.7,"Putre'thar");
	TJS_SetPos(16.8,44.7,"Rasthe");
	TJS_SetPos(26.3,54.9,"Relgor");
	TJS_SetPos(54.3,81.0,"Rendarr");
	TJS_SetPos(43.0,73.9,"Rendrak");
	TJS_SetPos(20.5,49.8,"Rogond the Tracker");
	TJS_SetPos(43.0,36.9,"Sergeant Mor'grak");
	TJS_SetPos(49.7,61.2,"Shadowthrash");
	TJS_SetPos(62.6,72.2,"Soulslicer");
	TJS_SetPos(65.2,37.0,"Steelsnout");
	TJS_SetPos(40.5,79.2,"Sylissa");
	TJS_SetPos(16.1,57.4,"Szirek the Twisted");
	TJS_SetPos(48.9,73.5,"The Blackfang");
	TJS_SetPos(34.9,72.5,"The Goreclaw");
	TJS_SetPos(13.0,57.0,"The Iron Houndmaster");
	TJS_SetPos(37.0,72.0,"The Night Haunter");
	TJS_SetPos(13.4,58.6,"Tho'gar Gorefist");
	TJS_SetPos(34.1,44.3,"Thromma the Gutslicer");
	TJS_SetPos(27.6,32.8,"Varyx the Damned");
	TJS_SetPos(60.0,21.2,"Xanzith the Everlasting");
	TJS_SetPos(48.4,28.6,"Zeter'el");
	TJS_SetPos(37.0,32.8,"Zoug the Heavy");
	
	TJS_SetPos(23.2,40.4,"Deathtalon");
	TJS_SetPos(15.4,63.6,"Terrorfist");
	TJS_SetPos(47.0,52.6,"Doomroller");
	TJS_SetPos(32.4,74.0,"Vengeance");
	TJS_SetPos(38.0,30.0,"Savage Whale Shark");
	TJS["Deathtalon"].class.stalk = false;	
	TJS["Terrorfist"].class.stalk = false;	
	TJS["Doomroller"].class.stalk = false;	
	TJS["Vengeance"].class.stalk = false;	
	TJS["Savage Whale Shark"].class.stalk = false;
		
	TJS["Deathtalon"].class.hellbane = true;	
	TJS["Terrorfist"].class.hellbane = true;	
	TJS["Doomroller"].class.hellbane = true;
	TJS["Vengeance"].class.hellbane = true;
	
	TJS["Savage Whale Shark"].class.plan = true;
	TJS["Belgork"].class.plan = true;
	TJS["(The Real) Captain Ironbeard"].class.plan = true;
	TJS["Cindral the Wildfire"].class.plan = true;
	TJS["Felsmith Damorka"].class.plan = true;
	TJS["Xanzith the Everlasting"].class.plan = true;
	TJS["Zoug the Heavy"].class.plan = true;
	
	TJS["Savage Whale Shark"].number.plan = 39355;
	TJS["Belgork"].number.plan = 38932;
	TJS["(The Real) Captain Ironbeard"].number.plan = 39365;
	TJS["Cindral the Wildfire"].number.plan = 39363;
	TJS["Felsmith Damorka"].number.plan = 39366;
	TJS["Xanzith the Everlasting"].number.plan = 39356;
	TJS["Zoug the Heavy"].number.plan = 39360;
	
	TJS["Savage Whale Shark"].text.plan = color.planName.."Trained Shark Tank (Counters: Minelayer)".."|r";
	TJS["Belgork"].text.plan = color.planName.."Bilge Pump (Counters: Stormy Weather)".."|r";
	TJS["(The Real) Captain Ironbeard"].text.plan = color.planName.."Ghostly Spyglass (Counters: Cursed  Crew)".."|r";
	TJS["Cindral the Wildfire"].text.plan = color.planName.."Ice Cutter (Counters: Icy Water)".."|r";
	TJS["Felsmith Damorka"].text.plan = color.planName.."Felsmoke Launcher (Counters: First Strike)".."|r";
	TJS["Xanzith the Everlasting"].text.plan = color.planName.."High Intensity Fog Lights (Counters: Dense Fog)".."|r";
	TJS["Zoug the Heavy"].text.plan = color.planName.."True Iron Rudder (Counters: Evasive)".."|r";

	TJS_SetTodayNum(39399, "Akrrilo");
	TJS_SetTodayNum(38430, "Argosh the Destroyer");
	TJS_SetTodayNum(38609, "Belgork");
	TJS_SetTodayNum(38262, "Bilkor the Thrower");
	TJS_SetTodayNum(38696, "Bleeding Hollow Horror");
	TJS_SetTodayNum(38266, "Bloodhunter Zulk");
	TJS_SetTodayNum(38209, "Bramblefell");
	TJS_SetTodayNum(38589, "Broodlord Ixkor");
	TJS_SetTodayNum(38820, "Captain Grok'mar");
	TJS_SetTodayNum(38756, "(The Real) Captain Ironbeard");
	TJS_SetTodayNum(38031, "Ceraxas");
	TJS_SetTodayNum(37990, "Cindral the Wildfire");
	TJS_SetTodayNum(38746, "Commander Krag'goth");
	TJS_SetTodayNum(38749, "Commander Org'mok");
	TJS_SetTodayNum(38265, "Dorg the Bloody");
	TJS_SetTodayNum(38736, "Driss Vile");
	TJS_SetTodayNum(38264, "Drivnul");
	TJS_SetTodayNum(38411, "Executor Riloth");
	TJS_SetTodayNum(39379, "Eyepiercer");
	TJS_SetTodayNum(38775, "Felbore");
	TJS_SetTodayNum(38634, "Felsmith Damorka");
	TJS_SetTodayNum(38211, "Felspark");
	TJS_SetTodayNum(38604, "Gloomtalon");
	TJS_SetTodayNum(38764, "Glub'glok");
	TJS_SetTodayNum(38709, "Gorabosh");
	TJS_SetTodayNum(38400, "Grand Warlock Nethekurse");
	TJS_SetTodayNum(38750, "Grannok");
	TJS_SetTodayNum(39046, "Harbormaster Korak");
	TJS_SetTodayNum(38026, "Imp-Master Valessa");
	TJS_SetTodayNum(38030, "Jax'zor");
	TJS_SetTodayNum(38605, "Krell the Serene");
	TJS_SetTodayNum(38825, "Kris'kar the Unredeemed");
	TJS_SetTodayNum(38029, "Lady Oran");
	TJS_SetTodayNum(38726, "Magwia");
	TJS_SetTodayNum(38032, "Mistress Thavra");
	TJS_SetTodayNum(38580, "Overlord Ma'gruth");
	TJS_SetTodayNum(38557, "Painmistress Selora");
	TJS_SetTodayNum(38282, "Podlord Wakkawam");
	TJS_SetTodayNum(38457, "Putre'thar");
	TJS_SetTodayNum(38034, "Rasthe");
	TJS_SetTodayNum(38496, "Relgor");
	TJS_SetTodayNum(39400, "Rendarr");
	TJS_SetTodayNum(38631, "Rendrak");
	TJS_SetTodayNum(38263, "Rogond the Tracker");
	TJS_SetTodayNum(37953, "Sergeant Mor'grak");
	TJS_SetTodayNum(38812, "Shadowthrash");
	TJS_SetTodayNum(38600, "Soulslicer");
	TJS_SetTodayNum(38700, "Steelsnout");
	TJS_SetTodayNum(38628, "Sylissa");
	TJS_SetTodayNum(38752, "Szirek the Twisted");
	TJS_SetTodayNum(38597, "The Blackfang");
	TJS_SetTodayNum(38654, "The Goreclaw");
	TJS_SetTodayNum(38751, "The Iron Houndmaster");
	TJS_SetTodayNum(38632, "The Night Haunter");
	TJS_SetTodayNum(38747, "Tho'gar Gorefist");
	TJS_SetTodayNum(38620, "Thromma the Gutslicer");
	TJS_SetTodayNum(37937, "Varyx the Damned");
	TJS_SetTodayNum(38579, "Xanzith the Everlasting");
	TJS_SetTodayNum(38207, "Zeter'el");
	TJS_SetTodayNum(39045, "Zoug the Heavy");
	
	TJS_SetTodayNum(39287,"Deathtalon");
	TJS_SetTodayNum(39288,"Terrorfist");
	TJS_SetTodayNum(39289,"Doomroller");
	TJS_SetTodayNum(39290,"Vengeance");
	TJS_SetTodayNum(36153,"Savage Whale Shark");
	
--	TJS_SetTitle("<Shadowhunter of the Blackfang>", "Akrrilo");
	TJS_SetTitle("<Grom'kar Strikeleader>", "Belgork");
	TJS_SetTitle("<Bleeding Hollow Spearmaster>", "Bilkor the Thrower");
	TJS_SetTitle("<Bleeding Hollow Assassin>", "Bloodhunter Zulk");
	TJS_SetTitle("<The True Scourge of the Iron Seas>", "(The Real) Captain Ironbeard");
	TJS_SetTitle("<Bleeding Hollow Aberration>", "Dorg the Bloody");
	TJS_SetTitle("<Iron Horde Master Sniper>", "Driss Vile");
	TJS_SetTitle("<Master of Rituals>", "Drivnul");
--	TJS_SetTitle("<Crazed Blackfang Warmonger>", "Eyepiercer");
	TJS_SetTitle("<Clawshaper of the Blackfang>", "Gloomtalon");
	TJS_SetTitle("<Keeper of the Cave>", "Gorabosh");
	TJS_SetTitle("<Blademaster of the Blackfang>", "Krell the Serene");
	TJS_SetTitle("<Crusader of Rukhmar>", "Kris'kar the Unredeemed");
	TJS_SetTitle("<Shadow Council>", "Overlord Ma'gruth");
	TJS_SetTitle("<Son of Sethe>", "Rasthe");
	TJS_SetTitle("<Bleeding Hollow Master Scout>", "Relgor");
--	TJS_SetTitle("<Warshaman of the Blackfang>", "Rendarr");
	TJS_SetTitle("<Direwing Alpha>", "Rendrak");
	TJS_SetTitle("<Bleeding Hollow Huntmaster>", "Rogond the Tracker");
	TJS_SetTitle("<Corrupted Shaman>", "Soulslicer");
	TJS_SetTitle("<Marshwater Queen>", "Sylissa");
	TJS_SetTitle("<Warboss of the Blackfang>", "The Blackfang");
	
	TJS_SetTitle("<Avatar of Iskar>", "Deathtalon");
	TJS_SetTitle("<Son of Kormrok>", "Terrorfist");
	TJS_SetTitle("<Mar'tak's Creation>", "Doomroller");
	TJS_SetTitle("<Avatar of Velhari>", "Vengeance");

	TJS["Painmistress Selora"].flag.event = true;

	TJS["Szirek the Twisted"].flag.summon = true;
	TJS["Dorg the Bloody"].flag.summon = true;
	TJS["Rendrak"].flag.summon = true;
	TJS["Akrrilo"].flag.summon = true;
	TJS["Eyepiercer"].flag.summon = true;
	TJS["The Night Haunter"].flag.summon = true;
	TJS["Rendarr"].flag.summon = true;
	
	TJS["Akrrilo"].class.fang = true;
	TJS["Eyepiercer"].class.fang = true;
	TJS["Rendarr"].class.fang = true;
	TJS["Soulslicer"].class.fang = true;
	TJS["Gloomtalon"].class.fang = true;
	TJS["Krell the Serene"].class.fang = true;
	TJS["The Blackfang"].class.fang = true;
	
	TJS["Gloomtalon"].flag.fangRep = true;
	TJS["Krell the Serene"].flag.fangRep = true;
	TJS["The Blackfang"].flag.fangRep = true;
	TJS["Gloomtalon"].text.fang = text.fangRep;
	TJS["Krell the Serene"].text.fang = text.fangRep;
	TJS["The Blackfang"].text.fang = text.fangRep;
	
	TJS["Soulslicer"].flag.fangRep = TJS_SetSSRep(); -- No longer necessary
	TJS["Soulslicer"].text.fang = text.SSRep;
	
	if not IsQuestFlaggedCompleted(39565) then
		TJS["Akrrilo"].flag.fangRep = true;
		TJS["Eyepiercer"].flag.fangRep = true;
		TJS["Rendarr"].flag.fangRep = true;
		TJS["Akrrilo"].text.fang = text.fangQ..text.fangRep;
		TJS["Eyepiercer"].text.fang = text.fangQ..text.fangRep;
		TJS["Rendarr"].text.fang = text.fangQ..text.fangRep;
	end
	
	TJS_SetNameColor();
	local cf = color.fang;
	local ct = color.title;
	local str = cf.."Akrrilo |r"..ct.."<Shadowhunter of the Blackfang>|r\n"..cf.."Eyepiercer |r"..ct.."<Crazed Blackfang Warmonger>|r\n"..cf.."Rendarr |r"..ct.."<Warshaman of the Blackfang>|r";
	TJS["Akrrilo"].text.name = str;
	TJS["Eyepiercer"].text.name = str;
	TJS["Rendarr"].text.name = str;

	local coord = "";
	coord = "(The Real) Captain Ironbeard";
	x = 37.5;
	y = 76.0;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);
	
	coord = "Podlord Wakkawam";
	x = 16.8;
	y = 48.7;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Zeter'el";
	x = 48.2;
	y = 32.8;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Jax'zor";
	x = 29.6;
	y = 70.6;
	name = TJS["Jax'zor"].text.name.."\n"..TJS["Mistress Thavra"].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Mistress Thavra";
	x = 29.6;
	y = 70.6;
	name = TJS["Jax'zor"].text.name.."\n"..TJS["Mistress Thavra"].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Gloomtalon";
	x = 62.2;
	y = 79.1;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "The Blackfang";
	x = 51.3;
	y = 75.3;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "The Goreclaw";
	x = 36.6;
	y = 72.3;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Kris'kar the Unredeemed";
	x = 42.3;
	y = 68.8;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Thromma the Gutslicer";
	x = 38.3;
	y = 44.4;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Felbore";
	x = 30.4;
	y = 52.6;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);

	coord = "Bleeding Hollow Horror";
	x = 44.4;
	y = 77.4;
	name = TJS[coord].text.name;
	TJS_SetCave(x, y, coord, name);
	
	TJS_SetFlags();
	TJS_SetText();
end

function TJS_SetText()
	for n,a in pairs(TJS) do
		t = nil
		local t=a.text;
		t.text = t.name..t.title..t.plan..t.fang;
		local temp = t.text;
		if a.flag.inCave then
			t.text = temp..text.inCave;
			temp = t.text;
		end
		if a.flag.event then
			t.text = temp..text.event;
			temp = t.text;
		end
		if a.flag.summon then
			t.text = temp..text.summon;
			temp = t.text;
		end
		a.text = t;
	end
end

function TJS_SetTodayNum(x, name)
	if TJS[name] then
		TJS[name].number.today = x;
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00B2FE<TJS>:|r|cffFF0000"..name.."|r");
	end
end

function TJS_SetTitle(t, name)
	if TJS[name] then
		TJS[name].text.title = "\n"..color.title..t.."|r";
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00B2FE<TJS>:|r|cffFF0000"..name.."|r");
	end
end

function TJS_SetNameColor()
	local acolor = "";
	for n,a in pairs(TJS) do
		if a.class.plan then
			acolor = color.plan;
		elseif a.class.hellbane then
			acolor = color.hellbane;
		elseif a.class.fang then
			acolor = color.fang;
		else
			acolor = color.stalk;
		end
		a.text.name = acolor..n.."|r";
	end
end

function TJS_SetCave(x, y, coord, name)
	TJS[coord]["cave"] = {
		["c"] = 7,
		["z"] = 8,
		["x"] = x,
		["y"] = y,
		["text"] = text.caveEnt..name,
	};
	TJS[coord].flag.inCave = true;
end

function TJS_SetFlags()
	for i = 1, GetAchievementNumCriteria(10070) do
		local name, v, complete = GetAchievementCriteriaInfo(10070, i);
		TJS[name].flag.achievement = complete;
	end
	for n,a in pairs(TJS) do
		local x = a.number.today;
		if x>0 then
			a.flag.today = IsQuestFlaggedCompleted(x);
		else
			TJS_Sound("error");
			DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000ERROR - NO Daily Number|r");
		end
		if a.class.plan then
			x = a.number.plan;
			if x>0 then
				a.flag.plan = IsQuestFlaggedCompleted(x);
			else
				TJS_Sound("error");
				DEFAULT_CHAT_FRAME:AddMessage("|cffFF0000ERROR - NO Plan Number|r");
			end
		end
	end
end

