﻿
--[[
--                                           MOUNTY ©2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
--Slash Command Events------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------
function TJS_SCommand(msg)
	local num2=0;num3=0;num4=0;
	if (msg) then
		msg=string.lower(msg);
		_,_, msg1, msg2, msg3, msg4 = string.find(msg, "(%S+) (%S+) (%S+) (%S+)");
		if not msg1 then _,_, msg1, msg2, msg3 = string.find(msg, "(%S+) (%S+) (%S+)") end
		if not msg1 then _,_, msg1, msg2 = string.find(msg, "(%S+) (%S+)") end
		if not msg1 then _,_, msg1 = string.find(msg, "(%S+)") end
		if msg1 then msg=msg1 else msg=nil end
		if msg2 then num2 = tonumber(msg2) end --, num2 = math.modf(num2) end
		if msg3 then num3 = tonumber(msg3) end --, num3 = math.modf(num3) end
		if msg2 then num4 = tonumber(msg4) end --, num4 = math.modf(num4) end
	end
	if msg then
		local a, b = "none", "none";
		if msg == "aa" then msg = "a"; msg2 = "a"; end
		if msg == "ha" then msg = "h"; msg2 = "a"; end
		if msg == "ta" then msg = "t"; msg2 = "a"; end
		if msg == "pd" then msg = "p"; msg2 = "d"; end
		if msg == "pa" then msg = "p"; msg2 = "a"; end
		if msg == "sd" then msg = "s"; msg2 = "d"; end
		if msg == "sa" then msg = "s"; msg2 = "a"; end
		if msg == "fa" then msg = "f"; msg2 = "a"; end
		if msg == "ra" then msg = "f"; msg2 = "a"; end
		a = TJS_HandleMSG(msg)
		msg = a;
		if msg2 then
			b = TJS_HandleMSG2(msg, msg2);
		end
		if a ~= "none" then
			TJS_SetSelected(a, b);
		else
			TJS_BadMessage(msg);
		end
	else
		TJS_PrintMenu();
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Localization
--------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables
--------------------------------------------------------------------------------------------------------------------------------
TJSLOADED = false;
TJSNOTSET = "None Set";
TJS_NAME = GetAddOnMetadata("TanaanJungleStalker", "Title");
TJS_VERSION = GetAddOnMetadata("TanaanJungleStalker", "Version");

function TJS_INFO()
	local sversion, build, builddate, tocversion = GetBuildInfo();
	local version = tonumber(string.sub(string.gsub(sversion, "%.", ""), 1, 2));
	local z = string.sub(string.gsub(sversion, "%.", ""), 1, 2);
	local y = string.sub(z, 1, 1);
	local x = string.sub(z, 2, -1);
	local ptocversion = "y0x00";
	ptocversion = string.gsub("y0x00", "y", y)
	ptocversion = string.gsub(ptocversion, "x", x)
	return tocversion, ptocversion, sversion, version;
end
TJS_TOC, TJS_WOWTOC, TJS_WOWBUILD, TJS_BUILD = TJS_INFO();

TJS_FILENUM = GetAddOnMetadata("TanaanJungleStalker", "X-FileNumber");
TJS_InWorld = false;
TJS_NoPoints = true;

TJS = {};

TJS_Pause = false;

--------------------------------------------------------------------------------------------------------------------------------
-- OnLoad
--------------------------------------------------------------------------------------------------------------------------------
function TJS_OnLoad(frame)
-- Create LUA Frames
	CreateFrame("GameTooltip","MountyToolTip",UIParent,"GameTooltipTemplate") -- Build pseudo-tooltip to use for scanning.

-- Register Events	
--	frame:RegisterEvent("ADDON_LOADED");
	frame:RegisterEvent("PLAYER_ENTERING_WORLD");
--	frame:RegisterEvent("CRITERIA_UPDATE");
--	frame:RegisterEvent("CRITERIA_EARNED");
--	frame:RegisterEvent("PLAYER_CONTROL_GAINED");
	
-- Slash Commands
	SlashCmdList["TJS"] = TJS_SCommand;
	SLASH_TJS1 = "/tjs";
	SLASH_TJS2 = "/TJS";
	SLASH_TJS3 = "/stalker";
	SLASH_TJS4 = "/junglestalker";
	SLASH_TJS5 = "/tanaanjunglestalker";
end

--------------------------------------------------------------------------------------------------------------------------------
-- OnEvent
--------------------------------------------------------------------------------------------------------------------------------
function TJS_OnEvent(frame, event, ...)
	if(event == "PLAYER_ENTERING_WORLD") then
		if not TJS_InWorld then
			TJS_InWorld = true;
			TJS_TIME = time();
			DEFAULT_CHAT_FRAME:AddMessage("|cffFAE103<Tanaan Jungle Stalker>|r  File: |cff00AA00"..TJS_FILENUM.."|r by |cff00B2FEDrae|r");
			TJS_InitializeVar();
			TJS_Create();
		end
	end
end

function TJS_SetTest()
	TJS_TEST = {GetFactionInfoByID(1850)};
	TJS_TEST["key"] = {
		"name",
		"description",
		"standingID",
		"barMin",
		"barMax",
		"barValue",
		"atWarWith",
		"canToggleAtWar",
		"isHeader",
		"isCollapsed",
		"hasRep",
		"isWatched",
		"isChild",
		["standingID"] = {
			"Hated",
			"Hostile",
			"Unfriendly",
			"Neutral",
			"Friendly",
			"Honored",
			"Revered",
			"Exalted",
		},
	};
end

--TJS_TEST = {GetNumItemUpgradeEffects()};
--for i = 1, GetNumItemUpgradeEffects(124565) do
--	TJS_UE[i] = {GetItemUpgradeEffect(i)};
--end
